import HUYA from './jce'
import { UI } from '@hyext/hy-ui'
import { isSameType, logDiff, toRealType } from '@esydoc/assert'
import {
  transofrmDataTreeNode2Value,
  isDateTreeNode
} from '@esydoc/doclet-parser'

const { Tip } = UI

const helper = (global.helper = {
  getJceInfo: () => {
    return {
      class: HUYA,
      uri: '8006'
    }
  },
  tip(...args) {
    Tip.show(...args)
  },
  renderType: node => {
    const dumpType = v => {
      if (Array.isArray(v)) {
        return v.map(v => {
          return dumpType(v)
        })
      } else if (typeof v === 'object' && v !== null) {
        return Object.keys(v).reduce((track, key) => {
          track[key] = dumpType(v[key])
          return track
        }, {})
      } else {
        if (v === null) return null
        // if (typeof v === 'string' && v !== '') return v // 可能是枚举的具体值
        // if (typeof v === 'number' && v !== 0) return v
        return typeof v
      }
    }

    return dumpType(transofrmDataTreeNode2Value(node))
  },
  assert(a, b) {
    // for example: undefined === undefined
    if (isDateTreeNode(a)) {
      const result = isSameType(a, b)
      if (!result.pass) {
        throw new Error('断言不通过：' + result.msg)
      }
    } else {
      if (a !== b) {
        throw new Error('断言不通过：' + logDiff('return', toRealType(a), toRealType(b)))
      }
    }
  },
  isDateTreeNode
})

export default helper
