import { UI } from '@hyext/hy-ui'
import React, { Component } from 'react'
import "./index.hycss";

const { View, Text, Button, Icon } = UI

function StatusButton(props) {
  return (
    <Button
      className="status-button"
      type="primary"
      onPress={props.onPress}
    >
      <View className="btn-inner">
        <Text className="btn-text">{props.text}</Text>
        <Icon
          type={props.iconType}
          tintColor={props.iconColor}
          size={props.size}
        ></Icon>
      </View>
    </Button>
  )
}

StatusButton.defaultProps = {
  size: 20,
  iconColor: '#000',
  iconType: '',
  text: '',
  onPress: null
}

export default StatusButton
