import React, { Component } from 'react'
import { Router, Route } from '@hyext/router'
import { UI } from '@hyext/hy-ui'
import QAPanel from './Home'
import Tests from './Tests'
import Detail from './Detail'
import './App.hycss'
import { createTestHandleHOC } from './TestHandle'
import { Provider } from 'react-redux'
import { stroe } from '../QA-handle/createUpdateDispatcher'
import "../QA-handle/helper";

const { View } = UI

const QAPanelWithTestHandle = createTestHandleHOC(QAPanel)

function App() {
  return (
    <Provider store={stroe}>
      <View className="container">
        <Router initialEntries={['/home']}>
          <Route path="/home" component={QAPanelWithTestHandle}></Route>
          <Route path="/tests" component={Tests}></Route>
          <Route path="/detail" component={Detail}></Route>
        </Router>
      </View>
    </Provider>
  )
}

export default App
