import { createSDKPolyfill } from "@hyext/utils";
import logger from "./logger";

const polyfillSDK = createSDKPolyfill({
  SDK: global.hyExt,
  paths: [
    'request',
    'env.getHostInfo'
  ],
  onCall(callArgs, apiName, path) {
    logger.log(`SDK.${path}开始调用`, callArgs)
  },
  onError(errMsg, apiName, path) {
    logger.log(`SDK.${path}调用失败`, errMsg)
  },
  onSuccess(res, apiName, path) {
    logger.log(`SDK.${path}调用成功`, res)
  },
})

export default polyfillSDK